freeslot("sfx_amydrp", "SPR2_DRPD", "S_PLAY_AMYDROP")
sfxinfo[sfx_amydrp].caption = "Hammer!"
states[S_PLAY_AMYDROP] = {SPR_PLAY, SPR2_DRPD, 1, nil, 0, 0, S_PLAY_AMYDROP}

--Reset variables on spawn
addHook("PlayerSpawn", function(p)
	p.mo.amyhammertimer = 0
	p.mo.amyhammertimer2 = 0
	p.mo.amydouble = false
	p.mo.amyhammer = false
	p.mo.amyhammering = false
	p.mo.amyhammersfx = false
end)

--The code
addHook("PlayerThink", function(p)
	if p.mo.skin == "amy"
		if p.mo.eflags & MFE_JUSTHITFLOOR
			if p.mo.amyhammertimer > 11
				p.mo.amyhammering = true
				p.mo.amyhammertimer2 = 60
			else
				p.mo.amyhammertimer = 0
			end
			p.mo.amydouble = false
			p.mo.amyhammer = false
		end
	
		if p.pflags & PF_JUMPED
			p.mo.amyhammer = true
			p.mo.amyhammering = false
			p.mo.amyhammertimer2 = 0
		end
	
		if p.cmd.buttons & BT_JUMP
		and p.pflags & PF_JUMPED
		and p.mo.amydouble
			p.mo.amyhammertimer = $+1
		else
			p.mo.amyhammertimer = 0
			if p.mo.state == S_PLAY_AMYDROP
				p.mo.state = S_PLAY_JUMP
			end
		end
	
		if p.mo.amyhammertimer == 12
			S_StartSound(p.mo,sfx_amydrp)
			p.mo.state = S_PLAY_AMYDROP
		end
	
		if not (p.cmd.buttons & BT_JUMP)
		or p.panim ~= PA_RUN
			p.mo.amyhammering = false
		end
	
		if p.mo.amyhammering
			p.powers[pw_strong] = $|(STR_ATTACK|STR_SPIKE|STR_SPRING)
			p.charflags = $|SF_CANBUSTWALLS
			P_SpawnGhostMobj(p.mo)
			p.mo.amyhammertimer2 = $-1
			if not p.mo.amyhammertimer2
				p.mo.amyhammering = false
			end
		
			if p.mo.frame == D
			and not p.mo.amyhammersfx
				S_StartSound(p.mo,sfx_s3k42)
				p.mo.amyhammersfx = true
			else
				p.mo.amyhammersfx = false
			end
		else
			p.powers[pw_strong] = $ &~(STR_ATTACK|STR_SPIKE|STR_SPRING)
			p.charflags = $ &~SF_CANBUSTWALLS
		end
	end
end)

--This
addHook("AbilitySpecial", function(p)
	if p.mo.skin == "amy"
	
		if not p.mo.amydouble
			p.mo.amydouble = true
			if not p.powers[pw_super]
				p.mo.momz = 10*FU
			else
				p.mo.momz = 15*FU
			end
			S_StartSound(p.mo,sfx_s25a)
		end
	end
end)